'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ArangoSerializer = require('js-abstract-synchronizer/serializer/ArangoSerializer');

var _ArangoSerializer2 = _interopRequireDefault(_ArangoSerializer);

var _HttpSerializer = require('js-abstract-synchronizer/serializer/HttpSerializer');

var _HttpSerializer2 = _interopRequireDefault(_HttpSerializer);

var _NotFoundError = require('js-abstract-synchronizer/errors/NotFoundError');

var _NotFoundError2 = _interopRequireDefault(_NotFoundError);

var _Serializer = require('js-abstract-synchronizer/serializer/Serializer');

var _Serializer2 = _interopRequireDefault(_Serializer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var serializers = {
  ArangoSerializer: _ArangoSerializer2.default,
  HttpSerializer: _HttpSerializer2.default
};

exports.default = {
  create: function create(_ref) {
    var implementationName = _ref.implementationName,
        implementationParams = _ref.implementationParams,
        prototypes = _ref.prototypes;

    var serializerImplementationClass = serializers[implementationName];

    if (typeof serializerImplementationClass === 'undefined') {
      throw new _NotFoundError2.default();
    }

    var serializerImplementation = new serializerImplementationClass(implementationParams);

    var serializer = new _Serializer2.default({
      prototypes: prototypes,
      serializerImplementation: serializerImplementation
    });

    return serializer;
  }
};